#pragma once

#include "MouseEvent.h"
#include "NPCommonUI.h"
#include "PropertyEvent.h"

class CNControl;

interface IStatable
{
public:
	virtual ~IStatable() {}
};
/**
 * \group NPCommonUI
 * \date 2007-06-19
 * \author hhd
 * \brief 
	{kr}
		4StatePanel ϱ ؼ  Ŭ.
		4StatePanel(ӱ) --> StateControl()
		콺 4(Normal, Over, Down, Dis) 콺 ׼ǿ  ׶׶  ϴ 뵵.
		NControl Attach/Detach ϴ  Ǿ ִ.
	{/kr}
 */
class NPCOMMONUI_API CStateControl : public IMouseListener, public IPropertyChangedListener
{
public:
	enum eControlState
	{
		E_CONTROLSTATE_NORMAL,
		E_CONTROLSTATE_OVER,
		E_CONTROLSTATE_DOWN,
		E_CONTROLSTATE_DIS,
	};
	enum eControlStyle
	{
		E_STYLE_NORMAL,
		E_STYLE_PUSH,
	};

	CStateControl();
	virtual ~CStateControl();

	static CComponent* FindStatable(CComponent* target);

	/**
	 * \brief {kr} 콺 ׼   Ÿ NControl Attach. {/kr}
	 * \param pControl 
	 */
	void AttachControl(CNControl* pControl);
	void DetachControl();

	/**
	 * \brief {kr}  콺 ׼ . {/kr}
	 * \return 
	 */
	eControlState GetState();

	BOOL IsPushed() { return m_bPushed; }
	void SetPushed(BOOL bPushed);
	
	void SetControlStyle(eControlStyle eStyle);

// override
	void OnMousePressed(CMouseEvent* pMouseEvent);
	void OnMouseReleased(CMouseEvent* pMouseEvent);
	void OnMouseEntered(CMouseEvent* pMouseEvent);
	void OnMouseExited(CMouseEvent* pMouseEvent);
	void OnMouseMoved(CMouseEvent* pMouseEvent);
	void OnMouseWheelMoved(CMouseEvent* pMouseEvent) {}

	void OnPropertyChanged(CPropertyChangeEvent* pPropertyChangedEvent);

protected:
private:
	CNControl*	m_pControl;
	eControlState	m_eControlState;
	eControlStyle	m_eControlStyle;
	BOOL	m_bPushed;
};